--- libeatmydata-26.orig/eatmydata.c
+++ libeatmydata-26/eatmydata.c
@@ -44,13 +44,17 @@ static int (*libc_msync)(void*, size_t,
         if (!libc_##name || dlerror())				\
                 _exit(1);
 
+static int initing = 0;
+
 void __attribute__ ((constructor)) eatmydata_init(void)
 {
+	initing = 1;
 	ASSIGN_DLSYM_OR_DIE(open);
 	ASSIGN_DLSYM_OR_DIE(fsync);
 	ASSIGN_DLSYM_OR_DIE(sync);
 	ASSIGN_DLSYM_OR_DIE(fdatasync);
 	ASSIGN_DLSYM_OR_DIE(msync);
+	initing = 0;
 }
 
 int eatmydata_is_hungry(void)
@@ -109,7 +113,7 @@ int open(const char* pathname, int flags
 
 	/* In pthread environments the dlsym() may call our open(). */
 	/* We simply ignore it because libc is already loaded       */
-	if (!libc_open) {
+	if (initing) {
 		errno = EFAULT;
 		return -1;
 	}
